package org.ntnu.pythia.engine;

import org.ntnu.pythia.game.GameObject;
import org.ntnu.pythia.game.LevelObject;

/**
 * This object defines center of rendering screen. It can be attached to a game
 * object to follow it.
 * @author egr
 *
 */
public class Camera implements Position {
	private GameObject followObject;
	private int x, y;
	
	public Camera() {
		x = y = 0;
	}
	
	public Camera(GameObject followObject) {
		this.followObject = followObject;
	}
	
	public void stopFollowing() {
		followObject = null;
	}
	
	public void follow(GameObject followObject) {
		this.followObject = followObject;
	}
	
	public GameObject getFollowingObject() {
		return followObject;
	}
	
	public void setPos(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	public int getX() {
		if (followObject != null) return followObject.getX();
		return x;
	}
	
	public int getY() {
		if (followObject != null) return followObject.getY();
		return y;
	}
	
	public double getDispX() {
		return -getX() + ResourceFactory.SCREEN_WIDTH / 2;
	}
	
	public double getDispY() {
		return -getY() + ResourceFactory.SCREEN_HEIGHT / 2 ;
	}
}
