package org.ntnu.pythia.engine;

import uk.co.flamingpenguin.jewel.cli.Option;

/**
 * Command-line options.
 * @author andreas
 *
 */
public interface Options {

	 @Option(longName = "level", 
			 shortName="l", 
			 defaultValue="",
			 description="The first level to be loaded in the game")
	 String getFirstLevel();
	 
	 @Option(longName = "external", 
			 shortName="x", 
			 description="The location of a level outside the jar.")
	 String getExternal();

	 boolean isExternal();
	 
	 @Option(longName = "debug", 
			 shortName="d", 
			 description="Runs the game in debug-mode. (Extra options in the console)")
	 boolean isDebug();
	 
	 @Option(longName = "sound", 
			 defaultValue="false", 
			 shortName="s", 
			 description="turns sound-effects on or off.")
	 boolean isSound();
	 
	 @Option(helpRequest = true, longName="help", shortName="?", description="This help message")
	 boolean getHelp();
}
