package org.ntnu.pythia.engine.components;

import java.io.IOException;
import java.io.OutputStream;

import de.matthiasmann.twl.EditField;

public class ConsoleOutputStream extends OutputStream {
	private final StringBuilder sb;
	private final EditField view;
	
	public ConsoleOutputStream(EditField view) {
		this.sb = new StringBuilder(2048);
		this.view = view;
	}
	@Override
	public void write(int b) throws IOException {
		sb.append((char)b);
		if (view != null)
			view.setText(sb.toString());
		//if (sb.length() > 4096) sb.delete(0, 1024);
	}
	
	public void clear() {
		sb.setLength(0);
		if (view != null)
			view.setText(sb.toString());
	}
}
