package org.ntnu.pythia.engine.components;

import org.ntnu.pythia.engine.App;

import de.matthiasmann.twl.BoxLayout;
import de.matthiasmann.twl.BoxLayout.Direction;
import de.matthiasmann.twl.Label;
import de.matthiasmann.twl.ResizableFrame;

public class HelpPanel extends ResizableFrame {
	BoxLayout box = new BoxLayout(Direction.HORIZONTAL);
	
	public static final int WIDGET_CONSOLE = 0x00000001;
	public static final int WIDGET_EDITOR =  0x00000010;
	
	public HelpPanel() {
        box.setTheme("/boxlayout");
        
        /*addLabel("F1 - Console");
        addLabel("F2 - Editor");
        addLabel("F5 - Run");
        addLabel("F6 - Step");
        addLabel("F7 - Resume");
        addLabel("F8 - Stop");
        addLabel("F9 - Show objectives");*/
        addLabel("F10 - Menu");
        
		setTheme("fixedframe");
		add(box);
		setCanAcceptKeyboardFocus(false);
	}
	
	private void addLabel(String text) {
		Label label = new Label(text);
		label.setTheme("/helplabel");
		box.add(label);
	}
	
	public void updateHelpPanel(int openedWindows) {
		box.removeAllChildren();
		if ((openedWindows & WIDGET_CONSOLE) != 0) {
			addLabel("F1 - Hide Console");
		}
		if ((openedWindows & WIDGET_EDITOR) != 0) {
			addLabel("F2 - Hide Editor");
	        addLabel("F5 - Run");
	        addLabel("F6 - Step");
	        addLabel("F7 - Resume");
	        addLabel("F8 - Stop");
		}
		if (openedWindows == 0) {
			if(App.globals.hasEditor()) addLabel("F2 - Show Editor");
			addLabel("F9 - Show objectives");
	        addLabel("F10 - Menu");
		}
	}
}
