package org.ntnu.pythia.engine.components;

import de.matthiasmann.twl.Event;
import de.matthiasmann.twl.PopupWindow;
import de.matthiasmann.twl.ScrollPane;
import de.matthiasmann.twl.TextArea;
import de.matthiasmann.twl.Widget;
import de.matthiasmann.twl.textarea.HTMLTextAreaModel;

public class MessageBox extends PopupWindow {
	private final CustomScrollPane scrollPane;
	
	class CustomScrollPane extends ScrollPane {
		public CustomScrollPane(Widget content) {
			super(content);
		}
		
		@Override
		protected final boolean handleEvent(Event evt) {
			return super.handleEvent(evt);
		}
	}

	public MessageBox(Widget owner, String text) {
		super(owner);
		HTMLTextAreaModel tam = new HTMLTextAreaModel();
		tam.setHtml(text);
		TextArea textArea = new TextArea(tam);
		textArea.setTheme("textarea");
		textArea.setDefaultStyleSheet();
		
		scrollPane = new CustomScrollPane(textArea);
		scrollPane.setTheme("/license-scrollpane");
		
		setTheme("fixedframe-title");
		add(scrollPane);
	}
	
	@Override
	protected boolean handleEventPopup(Event evt) {
		if (evt.isKeyPressedEvent()) {
			switch (evt.getKeyCode()) {
			case Event.KEY_RETURN:
				closePopup();
				return true;
			case Event.KEY_UP:
			case Event.KEY_DOWN:
			case Event.KEY_END:
			case Event.KEY_HOME:
				scrollPane.handleEvent(evt);
				return true;
			default:
				break;
			}
		}
		return false;
    }

}
