package org.ntnu.pythia.engine.components;

import java.io.IOException;
import java.io.OutputStream;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.concurrent.ConcurrentSkipListSet;

public class OutputSplitter extends OutputStream {

	Set<OutputStream> streams = new HashSet<OutputStream>();
	
	@Override
	public void write(int b) throws IOException {
		for(OutputStream os : streams)
			os.write(b);
	}
	
	synchronized public void addStream(OutputStream os){
		streams.add(os);
	}
	
	synchronized public void removeStream(OutputStream os){
		streams.remove(os);
	}

}
