package org.ntnu.pythia.engine.components;

import de.matthiasmann.twl.EditField;
import de.matthiasmann.twl.ResizableFrame;
import de.matthiasmann.twl.Timer;

public class StatusLine extends ResizableFrame {
	
	private static final int DELAY = 1000;
	
	private EditField line;
	private Timer timer;
	
	public StatusLine() {
		setTheme("fixedframe");
		line = new EditField();
		line.setText("");
		line.setReadOnly(true);
		line.setTheme("/editfield");
		line.setCanAcceptKeyboardFocus(false);
		setCanAcceptKeyboardFocus(false);
		add(line);
	}
	
	synchronized public void setText(String text) {
		if (timer == null) {
			timer = new Timer(getGUI());
			timer.setDelay(DELAY);
			timer.setCallback(new ClearText());
		}
		
		timer.stop();
		line.setText(text);
		timer.start();
		//Timer timer = new Timer(getGUI());		timer.
		//timer = new Timer();
		//timer.schedule(new ClearTask(), DELAY);
	}
	
	public boolean hasText() {
		return line.getTextLength() > 0;
	}
	
	class ClearText implements Runnable {
		public void run() {
			line.setText("");
		}
	}
}
