package org.ntnu.pythia.engine.lwjgl;

import java.awt.Color;

import org.lwjgl.opengl.GL11;
import org.ntnu.pythia.game.RenderObject;

public class LWJGLColorBox implements RenderObject {
	
	private org.lwjgl.util.Color glColor;
	
	public LWJGLColorBox(Color color) {
		glColor = new org.lwjgl.util.Color(color.getRed(), color.getGreen(), color.getBlue(), color.getAlpha());
	}

	@Override
	public int getWidth() {
		return 20;
	}

	@Override
	public int getHeight() {
		return 20;
	}

	@Override
	public void draw(double x, double y, double rot, int width, int height) {
		GL11.glPushMatrix();
		GL11.glTranslated(x-width / 2, y-height / 2, 0);
		GL11.glRotatef((float)rot, 0, 0, 1);
		GL11.glDisable(GL11.GL_TEXTURE_2D);
		
		GL11.glColorMaterial(GL11.GL_FRONT, GL11.GL_AMBIENT);
		GL11.glColor4ub(glColor.getRedByte(), glColor.getGreenByte(), glColor.getBlueByte(), glColor.getAlphaByte());
		
		GL11.glRectf(0, 0, width, height);
		
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glPopMatrix();
	}

	@Override
	public void pause() {
	}

	@Override
	public void resume() {
	}

	@Override
	public void drawShadow(double posX, double posY, double rot, int width,
			int height, int z_index) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void drawDamage(double posX, double posY, double rot, int width,
			int height, float damage) {
		// TODO Auto-generated method stub
		
	}

}
