package org.ntnu.pythia.game;

import org.ntnu.pythia.game.level.SimpleObject;
import org.ntnu.pythia.game.level.xml.CollisionScheme.ModelType;

/**
 * Static factory for creating CollisionModels from ManipulateableObjects
 * @author andreas
 *
 */
public class CollisionModelFactory {
	
	public static CollisionObject createCModel(SimpleObject origin){
		ModelType kind = ModelType.full;
		boolean movable = false;
		boolean solid = false;
		boolean backfires = true;
		if(origin.getCScheme() != null) {
			kind = origin.getCScheme().getType();
			movable = origin.getCScheme().isMoveable();
			solid = origin.getCScheme().isSolid();
			backfires = origin.getCScheme().doesBackfires();
		}
		if (solid)
		switch (kind){
		case full:
			return new CollisionObject(origin.getWidth(), origin.getHeight(), 0, 0, origin, movable, backfires);
		case tall:
			return new CollisionObject(origin.getWidth()*2/3, origin.getHeight()/2, 0, origin.getHeight()/4, origin, movable, backfires);
		case none:
		default:
		}
		return null;
	}
	
}
