package org.ntnu.pythia.game;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.ntnu.pythia.engine.ResourceFactory;

public class CollisionWorld {
	private List<GameObject> objects = new ArrayList<GameObject>();
	
	public CollisionWorld() { }
	
	public void add(GameObject o) {
		if (o != null) objects.add(o);
	}
	
	public void add(Collection<GameObject> os) {
		for(GameObject o : os)
			if (o != null) objects.add(o);
	}
	
	public void add(GameObject[] os) {
		for(GameObject o : os)
			if (o != null) objects.add(o);
	}
	
	public void remove(GameObject o) {
		objects.remove(o);
	}
	
	public void compute() {
		CollisionObject o1, o2;
		int count = 0;
		for (int i = 0; i < objects.size(); i++) {
			o1 = objects.get(i).getCollisionModel();
			if (o1 == null || !o1.movable) continue;
			for (int k = 0; k < objects.size(); k++) {
				if (k == i) continue;
				o2 = objects.get(k).getCollisionModel();
				if (o2 == null) continue;
				o1.collide(o2);
				count++;
			}
		}
	}
}
