package org.ntnu.pythia.game;

import org.ntnu.pythia.game.behaviour.CompositeObject;
import org.ntnu.pythia.game.level.SimpleObject;

public class CompositeCollisionObject extends CollisionObject {

	public CompositeCollisionObject(int width, int height, double posXdisp,
			double posYdisp, CompositeObject parent, boolean movable) {
		super(width, height, posXdisp, posYdisp, parent, movable);
	}
	
	@Override
	public void collide(CollisionObject o) {
		if (o == null || !o.movable) return;
		SimpleObject[] cells = ((CompositeObject)parent).getCells();
		for (SimpleObject cell : cells) {
			if(cell == null) continue;
			CollisionObject co = cell.getCollisionModel();
			if (co != null) co.collide(o);
		}
	}

}
