package org.ntnu.pythia.game;

import java.io.File;
import java.io.IOException;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Sequence;
import javax.sound.midi.Sequencer;

public class MusicObject {
	private Sequence sequence;
	private Sequencer sequencer;
	
	public MusicObject(String filename) {
	    try {
	    	sequence = MidiSystem.getSequence(MusicObject.class.getResourceAsStream(filename));
	    } catch (IOException e) {
	    	e.printStackTrace();
	    } catch (InvalidMidiDataException e) {
	    	e.printStackTrace();
		}
	}
	
	public void play() {
		try {
			sequencer = MidiSystem.getSequencer();
			sequencer.open();
			sequencer.setSequence(sequence);
			sequencer.setLoopStartPoint(0);
			sequencer.setLoopEndPoint(sequence.getTickLength());
			sequencer.start();
		} catch (MidiUnavailableException e) {
			e.printStackTrace();
		} catch (InvalidMidiDataException e) {
			e.printStackTrace();
		}
	}
	
	public void stop() {
		sequencer.stop();
		sequencer.close();
	}
	
	

}
