package org.ntnu.pythia.game;

/**
 * A sprite interface to draw sprite on the screen by the chosen renderer
 * @author egr
 *
 */
public interface RenderObject {
	
	/**
	 * Get the width of the sprite
	 * @return the width in pixels
	 */
	public int getWidth();
	
	/**
	 * Get the height of the sprite
	 * @return the height in pixels
	 */
	public int getHeight();
	
	/**
	 * Draw the sprite
	 * @param x the x coordinate of the sprite on the screen
	 * @param y the y coordinate of the sprite on the screen
	 */
	public void draw(double x, double y, double rotation, int width, int height);
	
	public void pause();
	public void resume();

	public void drawShadow(double posX, double posY, double rot, int width,
			int height, int z_index);

	public void drawDamage(double posX, double posY, double rot, int width,
			int height, float damage);

}
