package org.ntnu.pythia.game.level;

import java.awt.Color;

import org.ntnu.pythia.engine.ResourceFactory;

/**
 * The object that allows transition to the next level upon interaction. :)
 * @author andreas
 *
 */

public class ExitObject extends ManipulateableObject {

	protected String levelToBeLoaded;
		
	public ExitObject(String name, Color color, int xpos, int ypos, int z_index,
			int width, int height) {
		super(name, color, xpos, ypos, z_index, height, width);
	}

	public ExitObject(String name, String appearance, int x_position,
			int y_position, int z_index, int width, int height) {
		super(name, appearance, x_position, y_position, z_index, height, width);
	}

	/**
	 * Test if objectives are done, and triggers level transition.
	 */
	@Override
	public void talkTo(){
		if(ResourceFactory.getGameWorld().getTester().testAll())
			ResourceFactory.getGameWorld().loadLevel(levelToBeLoaded);
		else
			ResourceFactory.getGameWorld().showObjectives();
	}

	public void setLeveltobeLoaded(String levelToBeLoaded) {
		this.levelToBeLoaded = levelToBeLoaded;
	}
}
