package org.ntnu.pythia.game.level;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import org.ntnu.pythia.game.level.Appearance.RenderMethod;

@XmlRootElement(name = "Exit")
public class ExitObjectFactory extends ManipulateableObjectFactory {

	@XmlElement(name = "target", required = true)
	String levelToBeLoaded;
		
	@Override
	protected void construct() {
		try{
			if(appearance.getRendering().method == RenderMethod.TEXTURE){ 
				product = new ExitObject(name, appearance.getAppearance(), x_position, y_position, z_index, width, height);
			}else{
				Appearance.FillColor fc = (Appearance.FillColor) appearance.getRendering();
				product = new ExitObject(name, fc.getColor(), x_position, y_position, z_index, width, height);
				product.setColor(fc.getColor());
			}
		}catch (RuntimeException e) {
			throw new RuntimeException("Error in rendering definition for object '" + name + "'.", e);
		}
	}

	@Override
	protected void setValues(){
		super.setValues();
		if(levelToBeLoaded != null)
			((ExitObject)product).setLeveltobeLoaded(levelToBeLoaded);
	}
}
