package org.ntnu.pythia.game.level;

import java.util.List;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;

import org.ntnu.pythia.engine.ResourceFactory;

@XmlRootElement(name = "LevelSounds")
public class LevelSounds implements LoadableResource {
	@XmlElementRef
	private List<SoundRef> soundRefs;
	
	public void loadResource() {
		for(SoundRef g : soundRefs)
			g.load();
	}
	
	@XmlRootElement(name = "sound")
	public static class SoundRef {
		@XmlAttribute(name = "id", required = true)
		public String ref;
		@XmlAttribute(name = "src", required = true)
		public String src;
		void load(){
			System.out.println("Loading sound " + ref);
			ResourceFactory.getSoundObject(ref, src);
		}
	}
}
