package org.ntnu.pythia.game.level;

import java.io.InputStream;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import org.ntnu.pythia.python.Globals;

public class LoadableResourceLoader {

	public static void load(List<String> paths) {
		for(String path : paths){
			InputStream intStream = 
				Globals.class.getResourceAsStream(path);

			if (intStream == null)
				throw new RuntimeException("Error while opening internal file '" + path + "'.");

			JAXBContext context;
			LoadableResource r;
			try {
				context = JAXBContext.newInstance(LevelGraphics.class, LevelGraphics.AnimationRef.class, LevelSounds.class,
						LevelGraphics.GraphicRef.class, LevelGraphics.TextureRef.class, LevelSounds.SoundRef.class);
				Unmarshaller unmarshaller = context.createUnmarshaller();
				r = (LoadableResource)unmarshaller.unmarshal(intStream);
			} catch (JAXBException e) {
				throw new RuntimeException("Error while opening internal file '" + path + "'.", e);
			}
			r.loadResource();
		}
	}
}
