package org.ntnu.pythia.game.level.xml;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "CollisionScheme")
public class CollisionScheme {

	@XmlEnum
	public enum ModelType{
		/** A tall object that you can walk partially behind */
		@XmlEnumValue(value = "tall")
		tall,
		/** A fat object that covers the entire sprite */
		@XmlEnumValue(value = "full")
		full, 
		/** No collision */
		@XmlEnumValue(value = "no-collision")
		none
	}
	
	@XmlAttribute(name = "model")
	protected ModelType ctype = ModelType.full;
	
	@XmlAttribute(name = "solid")
	protected boolean csolid = true;
	
	@XmlAttribute(name = "backfires")
	protected boolean cbackfire = true;
	
	@XmlAttribute(name = "moveable")
	protected boolean cmoveable = false;
	
	
	public boolean isSolid(){
		return csolid;
	}
	
	public boolean isMoveable(){
		return cmoveable;
	}

	public ModelType getType() {
		return ctype;
	}

	public void setType(ModelType type) {
		this.ctype = type;
	}

	public void setSolid(boolean solid) {
		this.csolid = solid;
	}

	public void setMoveable(boolean moveable) {
		this.cmoveable = moveable;
	}

	public boolean doesBackfires() {
		return this.cbackfire;
	}
	
	public void setBackfires(boolean backfires) {
		this.cbackfire = backfires;
	}
}
