package org.ntnu.pythia.game.level.xml;

import java.util.List;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;
/**
 * Contains definitions for appearance of tiles in the levelLayout.
 * @author andreas
 *
 */
@XmlRootElement
public class TileDefinition {
	
	@XmlElementRef
	private List<TileRef> tileRefs;
	
	public List<TileRef> getAllTileRefs(){
		return tileRefs;
	}
	@XmlRootElement(name = "tile")
	public static class TileRef{
		/** What char will resolve to this tile in the layout */
		@XmlAttribute(name = "char", required = true)
		public String ref;
		
		@XmlAttribute(name = "id", required = true)
		public String id;
		
		@XmlElement
		public boolean solid = false;
		@XmlElement
		public boolean hollow = false;
		@XmlElement
		public int hurtfull = 0;
		@XmlElement
		public boolean water = false;
		
		public Character getChar() {
			if(ref == null || ref.length()<1)
				throw new RuntimeException("char in tile definition for tile '" + id + "' is missing.");
			if(ref.length()>1)
				throw new RuntimeException("char in tile definition for tile '" + id + "' is more than one character.");
			return ref.charAt(0);
		}

	}
	
}
