package org.ntnu.pythia.python;

import org.python.core.PyObject;

/**
 * Listens for function declarations.
 * @author andreas
 *
 */
public interface FunctionListener {

	/**
	 * Fires upon attempted function declaration.
	 * @param name
	 * @param newValue
	 */
	public void functionSet(String name, PyObject newValue);
	
	/**
	 * Will allow the function to be replaced if it returns true.
	 * @param name
	 * @param newValue
	 * @return true if the old function should be overwritten with a new one. 
	 */
	public boolean shouldOverwrite(String name, PyObject newValue);
	
	/**
	 * Fires upon attempted use of a function. (Not yet implemented)
	 * @param name
	 * @param arguments
	 */
	public void functionUsed(String name, PyObject arguments);
	
}
