package org.ntnu.pythia.python;

import org.python.core.Py;
import org.python.core.PyException;
import org.python.core.PyFrame;
import org.python.core.PyObject;
import org.python.core.TraceFunction;

public class GlobalTracer extends TraceFunction {
	private boolean interrupt = false;

	@Override
	public TraceFunction traceCall(PyFrame frame) {
		return this;
	}

	@Override
	public TraceFunction traceReturn(PyFrame frame, PyObject ret) {
		return this;
	}

	@Override
	public TraceFunction traceLine(PyFrame frame, int line) {
		if (interrupt) {
			interrupt = false;
			throw new PyException(Py.KeyboardInterrupt, "Interrupted by loser!" );
		}
		return this;
	}

	@Override
	public TraceFunction traceException(PyFrame frame, PyException exc) {
		return this;
	}

	public void interrupt() {
		interrupt  = true;
	}

}
