package org.ntnu.pythia.python;

import java.util.List;

import org.python.core.PyDictionary;
import org.python.core.PyObject;

public class ListenableDictionary extends PyDictionary {

	private String listName;
	private VariableListener listener;
	private List<ListListener> listListeners;
	
	protected ListenableDictionary(PyDictionary value, VariableListener listener, String listName) {
		super(value);
		this.listener = listener;
		this.listName = listName;
	}
	
	@Override
	public void __setitem__(PyObject index, PyObject value) {
		if(listener != null)
			listener.variableSet(listName + "['" + index + "']", value);
		if(listListeners != null)
			for(ListListener ll :listListeners)
				ll.variableSet(listName, index, value);
		super.__setitem__(index, value);
	}

	protected void addListener(List<ListListener> listListeners) {
		this.listListeners = listListeners;
	}
}
