package org.ntnu.pythia.python;

import org.python.core.PyException;


/**
 * A program editor that listens to events from the execution of the program that it wrote.
 * @author andreas
 */
public interface ListeningEditor {

	/**
	 * An error occured while parsing or executing.
	 * @param message
	 * @param lineNumber
	 */
	public void error(String message, int lineNumber, PyException e);
	
	/**
	 * The program is being executed.
	 * @param lineNumber
	 */
	public void executing(int lineNumber);
	
	/**
	 * The execution has completed
	 */
	public void finished();
	
	/**
	 * Returns the string containing the program
	 * @return
	 */
	public String getProgram();

	public void setProgram(String program);
}
