package org.ntnu.pythia.python;

import java.awt.Color;

import org.ntnu.pythia.engine.App;
import org.ntnu.pythia.engine.Camera;
import org.ntnu.pythia.engine.ResourceFactory;
import org.ntnu.pythia.game.GameObject;
import org.ntnu.pythia.game.level.Appearance;
import org.python.core.PyObject;

/**
 * A class with convenience methods to be called in python.
 * @author andreas
 *
 */
public class PythonLib {
		
	public static Color getColor(PyObject name){
		return Appearance.ColorChoice.byName(name.toString()).getColor();
	}

	public static void statusBar(String message){
		ResourceFactory.getGameWorld().statusUpdate(message);
	}
	/*
	 * XXX: this should be handled somewhere else. Put it here for now. (for testing)
	 * TODO: Remove tester from level. (put it in game?)
	 */
	 
	public static void showObjectives(){
		ResourceFactory.getGameWorld().showObjectives();
	}
/*	
	public static void haltScript(String scriptname){
		App.globals.getScript(scriptname).pause();
	}
	
	public static void unhaltScript(String scriptname){
		App.globals.getScript(scriptname).unpause();
	}
*/	
	
	public static void setVar(String var, String value){
		App.globals.setVar(var, value);
	}
	
	public static String getVar(String var){
		return App.globals.getVar(var);
	}
	
	public static String getLevelName(){
		return App.globals.getCurrentLevel().getLevelName();
	}
	
	public static int getLevelNumber(){
		return App.globals.getCurrentLevel().getLevelNumber();
	}
	
	public static void showNotice(String notice){
		ResourceFactory.getGameWorld().messageBox(notice);
	}
	
	public static void playSound(String ref) {
		ResourceFactory.getSoundObject(ref).play();
	}
	
	public static void showConsole(String text) {
		ResourceFactory.getGameWorld().showConsole(text);
	}
	
	public static void showConsole() {
		ResourceFactory.getGameWorld().showConsole();
	}
	
	public static void showEditor() {
		ResourceFactory.getGameWorld().showEditor();
	}
	
	public static GameObject getGameObject(String name) {
		return ResourceFactory.getGameWorld().getObjectByName(name);
	}
	
	public static Camera getCamera() {
		return ResourceFactory.getGameWorld().getCamera();
	}
	
	/*
	public static void main(String...args){
		PythiaParser p = new PythiaParser();
//		p.exec("from org.ntnu.pythia.python import PythonLib");
		p.exec("print PythonLib.getColor('red')");
		System.out.println(getColor("blue"));
		System.out.println(getColor("cheese"));
	}
	*/
}
