package org.ntnu.pythia.python.modulecontrol;

import java.util.LinkedList;
import java.util.List;

import org.ntnu.pythia.engine.App;
import org.ntnu.pythia.python.Globals;
import org.ntnu.pythia.python.PythiaParser;
import org.ntnu.pythia.python.VariableListener;
import org.python.core.PyBaseCode;
import org.python.core.PyFunction;
import org.python.core.PyObject;
import org.python.core.PySystemState;

/**
 * Controller for what modules, methods, classes are currently loaded and accessible. (abandoned project)
 * @author andreas
 *
 */

public class ModuleControl {

	public List<String> availableModules(){
		LinkedList<String> ret = new LinkedList<String>();
		for(String modname : App.globals.getModules().keySet())
			ret.add(modname);
		return ret;
	}
	
	public List<String> chosenModules(){
		LinkedList<String> ret = new LinkedList<String>();
		for(Object mod : PySystemState.builtin_module_names.toArray())
			ret.add(mod.toString());
		return ret;
	}
	
	public static void main(String...args){
		ModuleControl mc = new ModuleControl();
		App.output.addStream(System.out);
		Globals g = Globals.readGlobals();
		PythiaParser p = g.getParser();
		p.addListener("wheeo", new VariableListener() {
			@Override
			public void variableSet(String name, PyObject newValue) {
				if (newValue instanceof PyFunction) {
					PyFunction meth = (PyFunction) newValue;
					meth.__call__();
					System.out.println(name + " is a function");
					if (meth.func_code instanceof PyBaseCode) {
						PyBaseCode code = (PyBaseCode) meth.func_code;
//						code.
					}
					System.out.println("it is of length: (?) " + meth.func_code.co_name);
				}else
					System.out.println(name + " is not a function");
				System.out.println(newValue);
			}
		});
		g.getModule("test").load(p);
		p.exec("test()");
		p.exec("print dir()");
		p.exec("print dir(PythonLib)");
		
//		System.out.println(p.get("sys.modules"));
//		for(String s : mc.chosenModules())
//			System.out.println(s);
	}
}
