package org.ntnu.pythia.python.unit;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlList;
import javax.xml.bind.annotation.XmlRootElement;

import org.ntnu.pythia.game.level.Level;
import org.ntnu.pythia.python.ListListener;
import org.ntnu.pythia.python.PythiaParser;
import org.ntnu.pythia.python.VariableListener;
import org.python.core.PyFunction;
import org.python.core.PyList;
import org.python.core.PyObject;

/**
 * Tests a variable against a given value. 
 * @author andreas
 *
 */
@XmlRootElement(name = "TestListEquals")
public class ArrayTest extends Test {
	/*
	 * Named this way because of ListTest in java.	
	 */
	
	@XmlAttribute(name = "listname")
	protected String varName;

	@XmlElement(name = "values")
	@XmlList
	protected List<String> values;
	
	protected PythiaParser parser;
	
	@Override
	public void init(PythiaParser parser) {
		this.parser = parser;
	
	}

	@Override
	public boolean isSolved(Level level) {

		List currentValues = ((PyList)parser.get(varName));
		
		if(values.size() != currentValues.size()){
			System.out.println("correct size: " + values.size());
			System.out.println("current size: " + currentValues.size());
			return false;
		}
		for (int i = 0; i < values.size(); i++) {
			if(!values.get(i).trim().equalsIgnoreCase(currentValues.get(i).toString().trim())){
				return false;
			}
		}
		return true;
	}

	@Override
	public void setMethod(PyFunction f) {
		;
	}

}
