package org.ntnu.pythia.python.unit;

import java.io.IOException;
import java.io.OutputStream;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;

import org.ntnu.pythia.engine.App;
import org.ntnu.pythia.game.level.Level;
import org.ntnu.pythia.python.PythiaParser;
import org.python.core.PyFunction;

@XmlRootElement(name = "TestOutput")
public class OutputTest extends Test {

	@XmlAttribute(name = "regex")
	private String regex;
	
	StringBuilder builder;
	private OutputStream os;
	
	boolean done = false;
		
	private boolean isText(String regex){
		return builder.toString().trim().matches(regex);
	}
	
	@Override
	public boolean isSolved(Level level) {
		return done;
	}
	
	private void check(){
		if(!done)
			if(isText(regex))
				done = true;
		builder = new StringBuilder();
	}

	@Override
	public void init(PythiaParser parser) {
		done = false;
		builder = new StringBuilder();
		os = new OutputStream() {
			@Override
			public void write(int b) throws IOException {
				builder.append((char)b);
				if(b == '\n')
					check();
			}
		};
		App.output.addStream(os);
	}

	@Override
	public void setMethod(PyFunction f) {
		
	}
}
