package org.ntnu.pythia.python.unit;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;

import org.ntnu.pythia.engine.App;
import org.ntnu.pythia.game.level.Level;
import org.ntnu.pythia.python.Module;
import org.ntnu.pythia.python.PythiaParser;
import org.python.core.PyFunction;
import org.python.core.PyObject;

/**
 * Creates and emulates a {@link Test} implemented in Python.
 * @author andreas
 *
 */
@XmlRootElement(name = "PythonTest")
public class PyTestMaker extends Test{

	@XmlAttribute(name = "moduleName")
	protected String testModuleName;
	
	protected Test test;
	
	@Override
	public void init(PythiaParser parser) {
		Module m = App.globals.getModule(testModuleName);
		parser.exec("from org.ntnu.pythia.python.unit import Test");
		m.load(parser);
		PyObject behaviourClass = parser.get(m.getClassName());
		test = (Test) behaviourClass.__call__().__tojava__(Test.class);
		test.init(parser);
	}

	@Override
	public boolean isSolved(Level level) {
		return test.isSolved(level);
	}

	@Override
	public void setMethod(PyFunction f) {
		;
	}

}
