package org.ntnu.pythia.python.unit;

import javax.xml.bind.annotation.XmlAttribute;

import org.ntnu.pythia.game.level.Level;
import org.ntnu.pythia.python.PythiaParser;
import org.python.core.PyFunction;

/**
 * A test that has to pass for a player to clear a puzzle. 
 * @author andreas
 *
 */
public abstract class Test {
	
	/** A hint to be returned if the test fails.*/
	@XmlAttribute(name = "hint")
	public String hint;
	
	/**
	 * Is run before anything is changed in a puzzle.
	 * Used to set up listeners, load code, etc.
	 * @param parser The parser that the puzzle will be solved on.
	 */
	public abstract void init(PythiaParser parser);

	/**
	 * A custom written test to see if things are the way they are supposed to
	 * be upon completion of a level.
	 * @param level The level that is about to be completed.
	 * @return true if it is acceptable that a player starts the next level.
	 */
	public abstract boolean isSolved(Level level);
	
	/**
	 * 
	 * @return A hint to be returned if the test fails.
	 */
	public String getHint(){
		return hint;
	}

	public abstract void setMethod(PyFunction f);
	
}
