package org.ntnu.pythia.python.unit;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;

import org.ntnu.pythia.game.level.Level;
import org.ntnu.pythia.python.PythiaParser;
import org.ntnu.pythia.python.VariableListener;
import org.python.core.PyFunction;
import org.python.core.PyObject;

/**
 * Tests a variable against a given value. 
 * @author andreas
 *
 */
@XmlRootElement(name = "TestEquals")
public class VarTest extends Test{
		@XmlAttribute(name = "variable")
		String varName;

		@XmlAttribute(name = "value")
		String varValue;

		protected String currentValue = "";
		
		@Override
		public boolean isSolved(Level level) {
			return currentValue.equals(varValue);
		}

		@Override
		public void init(PythiaParser parser) {
			parser.addListener(varName, new VariableListener() {
				@Override
				public void variableSet(String name, PyObject newValue) {
					VarTest.this.currentValue = newValue.toString();
				}
			});
		}

		@Override
		public void setMethod(PyFunction f) {
			
		}
}
