from org.ntnu.pythia.game.behaviour import Behaviour

class BigDoorPassive(Behaviour):
    def __init__(self):
        self.opened = False
    
    def react(self, event, object):
        if event == "ew_open":
            self.open(object)
        if event == "ew_close":
            self.close(object)
        return True
    
    def open(self, object):
        if self.opened:
            return
        object.playSound("door")
        object.setSolid(False)
        object.changeRendering("bigdoor_opened")
        self.opened = True
    
    def close(self, object):
        if not self.opened:
            return
        object.playSound("door")
        object.setSolid(True)
        object.changeRendering("bigdoor_closed")
        self.opened = False