from org.ntnu.pythia.game.behaviour import Behaviour

class KillBot(Behaviour):
  def __init__(self):
    self.go = None
    
  def react(self, event, object):
    if event == "collision-north":
      self.go.setMoveUp(False)
      self.go.setMoveDown(True)
      return True
    if event == "collision-south":
      self.go.setMoveUp(True)
      self.go.setMoveDown(False)
      return True
    return False

  def nextFrame(self, angle, go):
    import math
    if angle > (math.pi*7/8) and angle < - (math.pi*7/8):
      go.setSprite("killbot_w")
    elif angle < (math.pi*7/8) and angle > (math.pi*5/8):
      go.setSprite("killbot_nw")
    elif angle < (math.pi*5/8) and angle > (math.pi*3/8):
      go.setSprite("killbot_n")
    elif angle < (math.pi*3/8) and angle > (math.pi*1/8):
      go.setSprite("killbot_ne")
    elif angle < (math.pi*1/8) and angle > - (math.pi*1/8):
      go.setSprite("killbot_e")
    elif angle < -(math.pi*1/8) and angle > - (math.pi*3/8):
      go.setSprite("killbot_se")
    elif angle < -(math.pi*3/8) and angle > - (math.pi*5/8):
      go.setSprite("killbot_s")
    elif angle < -(math.pi*5/8) and angle > - (math.pi*7/8):
      go.setSprite("killbot_sw")

  def timeElapsed(self, delta, go):
    import math
    if self.go == None:
      self.go = go
      go.setMoveUp(True)
    vX = go.getVx()
    vY = go.getVy()
    if (math.fabs(vX) + math.fabs(vY)) > 2:
      self.nextFrame(math.atan2(-vY, vX), go)
      go.resumeAnimation()
    else:
      go.pauseAnimation()