from org.ntnu.pythia.game.behaviour import Behaviour

class TestBehaviour(Behaviour):
 def __init__(self):
  self.y = 0
  self.x = 0
  self.right = True
  self.down = True
  self.left = False
  self.up = False
  self.quotes = ["WHY AM I GLOWING?", "WHAT TIME IS IT?", "ALL YOUR BASE ARE BELONG TO US", "LET ME OUT OF HERE!!!"]

 def react(self, event, object):
  msg = event
  if msg == "collision-west":
   self.right = True
   self.left = False
   object.playSound("pang1")
   return True
  if msg == "collision-east":
   self.right = False
   self.left = True
   object.playSound("pang1")
   return True
  if msg == "collision-north":
   self.up = False
   self.down = True
   object.playSound("pang1")
   return True
  if msg == "collision-south":
   self.up = True
   self.down = False
   object.playSound("pang1")
  return True
   
 def randomDirection(self):
  import random
  return True if random.random() < 0.5 else False
  
 def nextFrame(self, angle, go):
  import math
  if angle > (math.pi*7/8) and angle < - (math.pi*7/8):
   go.setSprite("snake_w")
  elif angle < (math.pi*7/8) and angle > (math.pi*5/8):
   go.setSprite("snake_nw")
  elif angle < (math.pi*5/8) and angle > (math.pi*3/8):
   go.setSprite("snake_n")
  elif angle < (math.pi*3/8) and angle > (math.pi*1/8):
   go.setSprite("snake_ne")
  elif angle < (math.pi*1/8) and angle > - (math.pi*1/8):
   go.setSprite("snake_e")
  elif angle < -(math.pi*1/8) and angle > - (math.pi*3/8):
   go.setSprite("snake_se")
  elif angle < -(math.pi*3/8) and angle > - (math.pi*5/8):
   go.setSprite("snake_s")
  elif angle < -(math.pi*5/8) and angle > - (math.pi*7/8):
   go.setSprite("snake_sw")

 def timeElapsed(self, delta, go):
  import math
  import random
  self.x += delta
  self.y += delta
  vX = go.getVx()
  vY = go.getVy()
  if (math.fabs(vX) + math.fabs(vY)) > 2:
   self.nextFrame(math.atan2(-vY, vX), go)
   go.resumeAnimation()
  else:
   go.pauseAnimation()
  go.setMoveUp(self.up)
  go.setMoveDown(self.down)
  go.setMoveLeft(self.left)
  go.setMoveRight(self.right)
  if self.x > 10:
   self.right = self.randomDirection()
   self.down = self.randomDirection()
   self.left = not self.right
   self.up = not self.down
   self.x = 0
  if self.y > 25:
   go.say(random.choice(self.quotes))
   self.y = 0
