package org.ntnu.other;

import junit.framework.TestCase;

public class FloatArithmeticPerformance extends TestCase {
	private static final int ITERATIONS = Integer.MAX_VALUE;
	public void testDoubleAdding() {
		double a = 102.4523543, b= 0.0543654, result;
		long startTime = System.nanoTime();
		for (int i = 0; i < ITERATIONS; i++) {
			result = a + b;
			a = result;
		}
		
		long endTime = System.nanoTime();
		System.out.println("Double adding completed in " + ((endTime-startTime)/1000000) + " ms");
	}
	
	public void testFloatAdding() {
		float a = 102.4523543f, b = 0.0543654f, result;
		long startTime = System.nanoTime();
		for (int i = 0; i < ITERATIONS; i++) {
			result = a + b;
			a = result;
		}
		
		long endTime = System.nanoTime();
		System.out.println("Float adding completed in " + ((endTime-startTime)/1000000) + " ms");
	}
	
	public void testDoubleMultipling() {
		double a = 102.4523543, b= 0.0543654, result;
		long startTime = System.nanoTime();
		for (int i = 0; i < ITERATIONS; i++) {
			result = a * b;
			a = result;
		}
		
		long endTime = System.nanoTime();
		System.out.println("Double multipling completed in " + ((endTime-startTime)/1000000) + " ms");
	}
	
	public void testFloatMultipling() {
		float a = 102.4523543f, b= 0.0543654f, result;
		long startTime = System.nanoTime();
		for (int i = 0; i < ITERATIONS; i++) {
			result = a * b;
			a = result;
		}
		
		long endTime = System.nanoTime();
		System.out.println("Float multipling completed in " + ((endTime-startTime)/1000000) + " ms");
	}
	
	public void testDoubleDividing() {
		double a = 102.4523543, b= 0.0543654, result;
		long startTime = System.nanoTime();
		for (int i = 0; i < ITERATIONS; i++) {
			result = a / b;
			a = result;
		}
		
		long endTime = System.nanoTime();
		System.out.println("Double dividing completed in " + ((endTime-startTime)/1000000) + " ms");
	}
	
	public void testFloatDividing() {
		float a = 102.4523543f, b= 0.0543654f, result;
		long startTime = System.nanoTime();
		for (int i = 0; i < ITERATIONS; i++) {
			result = a / b;
			a = result;
		}
		
		long endTime = System.nanoTime();
		System.out.println("Float dividing completed in " + ((endTime-startTime)/1000000) + " ms");
	}
}
