package org.ntnu.pythia;

import org.ntnu.pythia.python.PythiaParser;

import junit.framework.TestCase;

public class PythiaParserTest extends TestCase{
	//see PythiaParserTest.py for more details

	PythiaParser p = new PythiaParser();

	public void setUp() {

    }

	public void testVariableListener(){
	
		TestListener t = new TestListener();
		p.addListener("per", t);
		
		p.execfile("src/test/resources/PythiaParserTest.py");
			
		assertTrue(t.hasfired());
		assertEquals(p.eval("per").toString(), "hei");
	}
	
	public void testSingleListBind(){
		
		TestListener t = new TestListener();
		p.addListener("array[2]", t);
		
		p.execfile("src/test/resources/PythiaParserTest.py");
		
		assertTrue(t.hasfired());
		assertEquals(p.eval("array").toString(), "[1, 2, 9, 4]");
		
	}
	
	public void testRandomListBind(){
		TestListListener t = new TestListListener();
		p.addListener("array", t);
		
		p.execfile("src/test/resources/PythiaParserTest.py");
		assertEquals(t.getFired().asIndex(), 2);
		assertEquals(p.eval("array").toString(), "[1, 2, 9, 4]");
	}
	
	public void testRandomDictBind(){
		TestListListener t = new TestListListener();
		p.addListener("dict", t);
		
		p.execfile("src/test/resources/PythiaParserTest.py");
		assertEquals(t.getFired().toString(), "key");
		assertEquals(p.eval("dict['key']").toString(), "4");
	}
	
	public void testSingleDictBind(){
		TestListener t = new TestListener();
		p.addListener("dict['key']", t);
		
		p.execfile("src/test/resources/PythiaParserTest.py");
		assertTrue(t.hasfired());
		assertEquals(p.eval("dict['key']").toString(), "4");
	}

}
